summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorBruno Haible <bruno@clisp.org>2020-12-26 14:40:49 +0100
committerBruno Haible <bruno@clisp.org>2020-12-26 14:40:49 +0100
commitb42620e8d20cfcb5d18f452a38aa05500d3ada35 (patch)
tree55ea24fd0d7c22b6b3d3c13e0bc7d301cd3a0ad8
parent6b1f82435bc2f900429b711d90e25857d817eafe (diff)
downloadgnulib-b42620e8d20cfcb5d18f452a38aa05500d3ada35.tar.gz
execle: Add tests.
* tests/test-execle-main.c: New file. * tests/test-execle.sh: New file. * modules/execle-tests: New file.
-rw-r--r--ChangeLog5
-rw-r--r--modules/execle-tests11
-rw-r--r--tests/test-execle-main.c51
-rwxr-xr-xtests/test-execle.sh48
4 files changed, 115 insertions, 0 deletions
diff --git a/ChangeLog b/ChangeLog
index 6a8939cef5..e7a8228ce5 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,10 @@
2020-12-26 Bruno Haible <bruno@clisp.org>
+ execle: Add tests.
+ * tests/test-execle-main.c: New file.
+ * tests/test-execle.sh: New file.
+ * modules/execle-tests: New file.
+
execle: New module.
* lib/execle.c: New file.
* m4/execle.m4: New file.
diff --git a/modules/execle-tests b/modules/execle-tests
new file mode 100644
index 0000000000..d752b2cd02
--- /dev/null
+++ b/modules/execle-tests
@@ -0,0 +1,11 @@
+Files:
+tests/test-execle.sh
+tests/test-execle-main.c
+tests/test-exec-child.c
+tests/signature.h
+
+Depends-on:
+
+Makefile.am:
+TESTS += test-execle.sh
+check_PROGRAMS += test-execle-main test-exec-child
diff --git a/tests/test-execle-main.c b/tests/test-execle-main.c
new file mode 100644
index 0000000000..50d5899887
--- /dev/null
+++ b/tests/test-execle-main.c
@@ -0,0 +1,51 @@
+/* Test of execle().
+ Copyright (C) 2020 Free Software Foundation, Inc.
+
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 3, or (at your option)
+ any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, see <https://www.gnu.org/licenses/>. */
+
+/* Written by Bruno Haible <bruno@clisp.org>, 2020. */
+
+#include <config.h>
+
+/* Specification. */
+#include <unistd.h>
+
+#include "signature.h"
+SIGNATURE_CHECK (execle, int, (const char *, const char *, ...));
+
+#include <stdio.h>
+
+int
+main ()
+{
+ const char *progname = "./test-exec-child";
+ const char *env[3] = { "PATH=.", "Hommingberg=Gepardenforelle", NULL };
+ execle (progname,
+ progname,
+ "abc def",
+ "abc\"def\"ghi",
+ "xyz\"",
+ "abc\\def\\ghi",
+ "xyz\\",
+ "???",
+ "***",
+ "",
+ "foo",
+ "",
+ NULL,
+ env);
+
+ perror ("execle");
+ return 1;
+}
diff --git a/tests/test-execle.sh b/tests/test-execle.sh
new file mode 100755
index 0000000000..76469b7172
--- /dev/null
+++ b/tests/test-execle.sh
@@ -0,0 +1,48 @@
+#!/bin/sh
+
+# Test of execle().
+#
+# Copyright (C) 2020 Free Software Foundation, Inc.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>. */
+#
+# Written by Bruno Haible <bruno@clisp.org>, 2020.
+
+${CHECKER} ./test-execle-main${EXEEXT} > test-execle.tmp
+result=$?
+test $result = 49 || exit 1
+LC_ALL=C tr -d '\r' < test-execle.tmp > test-execle.out || exit 1
+
+cat > test-execle.ok <<\EOF
+argc = 11
+argv[1] = |abc def|
+argv[2] = |abc"def"ghi|
+argv[3] = |xyz"|
+argv[4] = |abc\def\ghi|
+argv[5] = |xyz\|
+argv[6] = |???|
+argv[7] = |***|
+argv[8] = ||
+argv[9] = |foo|
+argv[10] = ||
+Hommingberg = |Gepardenforelle|
+EOF
+
+: ${DIFF=diff}
+${DIFF} test-execle.ok test-execle.out
+result=$?
+
+rm -f test-execle.tmp test-execle.out test-execle.ok
+
+exit $result